Bug 1247795 - Review Request: execstack - Utility to set/clear/query executable stack bit
Review Request: execstack - Utility to set/clear/query executable stack bit
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Dominik 'Rathann' Mierzejewski
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 1239815 1248033 1248034
  Show dependency treegraph
 
Reported: 2015-07-28 18:36 EDT by Zbigniew Jędrzejewski-Szmek
Modified: 2015-08-04 11:54 EDT (History)
1 user (show)

See Also:
Fixed In Version: execstack-0.5.0-8.fc24
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-08-04 11:54:51 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
dominik: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Zbigniew Jędrzejewski-Szmek 2015-07-28 18:36:53 EDT
Spec URL: http://in.waw.pl/~zbyszek/fedora/execstack.spec
SRPM URL: http://in.waw.pl/~zbyszek/fedora/execstack-0.5.0-8.fc24.src.rpm
Fedora Account System Username: zbyszek
Description:
This package is built from prelink sources but contains just the
execstack binary. It can be used manipulate ELF binaries to run
with or without executable stack.

This package replaces prelink.
Comment 1 Dominik 'Rathann' Mierzejewski 2015-07-31 09:53:32 EDT
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[!]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 40960 bytes in 5 files.
[!]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Spec use %global instead of %define unless justified.
     Note: %define requiring justification: %define date 20131005
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: SourceX is a working URL.
[x]: Package should compile and build into binary rpms on all supported
     architectures.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: There are rpmlint messages (see attachment).
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: execstack-0.5.0-8.fc24.x86_64.rpm
          execstack-0.5.0-8.fc24.src.rpm
execstack.x86_64: W: no-url-tag
execstack.x86_64: W: obsolete-not-provided prelink
execstack.x86_64: E: incorrect-fsf-address /usr/share/licenses/execstack/COPYING
execstack.src: W: spelling-error %description -l en_US prelink -> preshrink
execstack.src: W: no-url-tag
2 packages and 0 specfiles checked; 1 errors, 4 warnings.




Rpmlint (debuginfo)
-------------------
Checking: execstack-debuginfo-0.5.0-8.fc24.x86_64.rpm
execstack-debuginfo.x86_64: W: no-url-tag
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/execstack.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/fptr.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/arch-ppc64.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/arch-sparc64.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/arch-x86_64.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/mdebug.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/arch-i386.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/dwarf2.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/fptr.h
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/arch-mips.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/layout.h
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/arch-arm.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/arch-s390x.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/hashtab.h
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/data.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/prelink.h
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/dso.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/arch-ia64.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/arch-s390.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/stabs.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/arch-sparc.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/arch-alpha.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/checksum.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/arch-sh.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/arch-ppc.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/crc32.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/hashtab.c
1 packages and 0 specfiles checked; 27 errors, 1 warnings.





Rpmlint (installed packages)
----------------------------
execstack.x86_64: W: no-url-tag
execstack.x86_64: W: obsolete-not-provided prelink
execstack.x86_64: E: incorrect-fsf-address /usr/share/licenses/execstack/COPYING
execstack-debuginfo.x86_64: W: no-url-tag
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/arch-mips.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/mdebug.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/arch-ppc.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/arch-s390.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/layout.h
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/crc32.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/arch-x86_64.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/data.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/arch-ppc64.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/fptr.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/prelink.h
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/arch-alpha.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/stabs.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/hashtab.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/arch-sparc64.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/dso.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/checksum.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/dwarf2.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/hashtab.h
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/execstack.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/arch-arm.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/arch-sparc.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/arch-ia64.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/fptr.h
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/arch-s390x.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/arch-sh.c
execstack-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/prelink-4c79120bcdbde0616f592458ccde7035e92ca3d8/src/arch-i386.c
2 packages and 0 specfiles checked; 28 errors, 3 warnings.



Requires
--------
execstack (rpmlib, GLIBC filtered):
    coreutils
    findutils
    gawk
    glibc
    grep
    libc.so.6()(64bit)
    libelf.so.1()(64bit)
    libelf.so.1(ELFUTILS_1.0)(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libgcc_s.so.1(GCC_3.3.1)(64bit)
    libselinux.so.1()(64bit)
    rtld(GNU_HASH)
    util-linux



Provides
--------
execstack:
    execstack
    execstack(x86-64)



Source checksums
----------------
https://github.com/keszybz/prelink/archive/4c79120bcdbde0616f592458ccde7035e92ca3d8.tar.gz#/prelink-4c79120.tar.gz :
  CHECKSUM(SHA256) this package     : fab35685d704de83e71b84a6875ce50218bf45ff9e64d114427975489840ff46
  CHECKSUM(SHA256) upstream package : fab35685d704de83e71b84a6875ce50218bf45ff9e64d114427975489840ff46


Generated by fedora-review 0.5.3 (bcf15e3) last change: 2015-05-04
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -b 1247795
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 2 Dominik 'Rathann' Mierzejewski 2015-07-31 09:55:36 EDT
Things to fix:

1. Please justify
# For now
ExclusiveArch: %{ix86} alpha sparc sparcv9 sparc64 s390 s390x x86_64 ppc ppc64 %{arm}

2. Please drop
Group: System Environment/Base

Otherwise it looks fine.
Comment 3 Zbigniew Jędrzejewski-Szmek 2015-07-31 11:28:56 EDT
Thanks for taking this.

I removed both ExclusiveArch and Group. EA was taken from the prelink package, but it looks like it might not be needed at all. The only architecture that is still present in Fedora, and was not on this list, is MIPS.

spec and srpm updated in place.
Comment 4 Dominik 'Rathann' Mierzejewski 2015-07-31 17:21:52 EDT
(In reply to Zbigniew Jędrzejewski-Szmek from comment #3)
> Thanks for taking this.

Thanks for resurrecting execstack. Several of my packages depend on it at build time.

> I removed both ExclusiveArch and Group. EA was taken from the prelink
> package, but it looks like it might not be needed at all. The only
> architecture that is still present in Fedora, and was not on this list, is
> MIPS.
> 
> spec and srpm updated in place.

Great, the package is APPROVED, though I do have a couple more nitpicks you can fix when importing:

1. Please drop Requires: glibc >= 2.2.4-18 (EL-5 has glibc-2.5) and reformat the rest of the (Build)Requires one per-line and sort alphabetically.

2. Please add a comment explaining this in %build:
sed -i -e '/^prelink_LDADD/s/$/ -lpthread/' src/Makefile.{am,in}

3. Please add -p to install commands:
install -D src/execstack %{buildroot}%{_bindir}/execstack
install -Dm0644 doc/execstack.8 %{buildroot}%{_mandir}/man8/execstack.8
Comment 5 Zbigniew Jędrzejewski-Szmek 2015-08-01 14:26:09 EDT
Thanks you for the review.

New Package SCM Request
=======================
Package Name: execstack
Short Description: Utility to set/clear/query executable stack bit
Upstream URL: https://sourceware.org/svn/prelink/trunk/
Owners: zbyszek
Branches: f23
InitialCC: jakub
Comment 6 Zbigniew Jędrzejewski-Szmek 2015-08-01 14:34:18 EDT
(In reply to Dominik 'Rathann' Mierzejewski from comment #4)
> 1. Please drop Requires: glibc >= 2.2.4-18 (EL-5 has glibc-2.5) and reformat
> the rest of the (Build)Requires one per-line and sort alphabetically.
Done. I also dropped all Requires. They don't seem necessary.

> 2. Please add a comment explaining this in %build:
> sed -i -e '/^prelink_LDADD/s/$/ -lpthread/' src/Makefile.{am,in}
This wasn't neceessary either, dropped.
 
> 3. Please add -p to install commands:
> install -D src/execstack %{buildroot}%{_bindir}/execstack
> install -Dm0644 doc/execstack.8 %{buildroot}%{_mandir}/man8/execstack.8
Done.
Comment 7 Gwyn Ciesla 2015-08-04 09:10:31 EDT
Git done (by process-git-requests).
Comment 8 Zbigniew Jędrzejewski-Szmek 2015-08-04 11:54:51 EDT
Built for rawhide and F23, submitted as an update and buildroot override for F23.

Note You need to log in before you can comment on or make changes to this bug.